---
title: XMLHttpRequest.setRequestHeader()
slug: Web/API/XMLHttpRequest/setRequestHeader
tags:
  - API
  - HTTP
  - HTTP Header
  - Method
  - NeedsExample
  - Reference
  - Request header
  - XHR
  - XHR Request
  - XMLHttpRequest
  - header
  - request
  - setRequestHeader
---
<div>{{APIRef('XMLHttpRequest')}}</div>

<p>The {{domxref("XMLHttpRequest")}} method <code><strong>setRequestHeader()</strong></code> sets the value of an HTTP request header. When using <code>setRequestHeader()</code>, you must call it after calling {{domxref("XMLHttpRequest.open", "open()")}}, but before calling {{domxref("XMLHttpRequest.send", "send()")}}. If this method is called several times with the same header, the values are merged into one single request header.</p>

<p>Each time you call <code>setRequestHeader()</code> after the first time you call it, the specified text is appended to the end of the existing header's content.</p>

<p>If no {{HTTPHeader("Accept")}} header has been set using this, an <code>Accept</code> header with the type <code>"*/*"</code> is sent with the request when {{domxref("XMLHttpRequest.send", "send()")}} is called.</p>

<p>For security reasons, some headers can only be controlled by the user agent. These headers include the {{Glossary("Forbidden_header_name", "forbidden header names", 1)}} and {{Glossary("Forbidden_response_header_name", "forbidden response header names", 1)}}.</p>

<div class="note">
<p><strong>Note:</strong> For your custom fields, you may encounter a "<strong>not allowed by Access-Control-Allow-Headers in preflight response</strong>" exception when you send requests across domains. In this situation, you need to set up the {{HTTPHeader("Access-Control-Allow-Headers")}} in your response header at server side.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>XMLHttpRequest</var>.setRequestHeader(<var>header</var>, <var>value</var>)
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>header</code></dt>
 <dd>The name of the header whose value is to be set.</dd>
 <dt><code>value</code></dt>
 <dd>The value to set as the body of the header.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p><code>undefined</code>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('XMLHttpRequest', '#the-setrequestheader()-method', 'setRequestHeader()')}}</td>
   <td>{{Spec2('XMLHttpRequest')}}</td>
   <td>WHATWG living standard</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XMLHttpRequest.setRequestHeader")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/XMLHttpRequest/Using_XMLHttpRequest">Using XMLHttpRequest</a></li>
 <li><a href="/en-US/docs/Web/API/XMLHttpRequest/HTML_in_XMLHttpRequest">HTML in XMLHttpRequest</a></li>
</ul>
